/*
** Module   : longchar.java
** Abstract : Progress 4GL compatible longchar object
**
** Copyright (c) 2012, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- ---------------------Description----------------------
** 001 AIL 20121206 Created initial version to support for Progress
**                  LONGCHAR type.
*/

package com.goldencode.p2j.util;

/**
 * A class that represents a Progress 4GL compatible longchar object whose
 * data is mutable.
 */
public class longchar
extends Text
{
   /**
    * Default constructor, creates an instance that represents the unknown
    * value.
    */
   public longchar()
   {
      super();
   }
   
   /**
    * Constructs an instance that has the <code>String</code> value passed
    * in and which <b>does not</b> represent the <code>unknown value</code>,
    * unless the <code>value</code> argument is <code>null</code>.
    *
    * @param    value
    *           The character value of the resulting instance.
    */
   public longchar(String value)
   {
      super(value);
   }
   
   /**
    * Constructs an instance that has the <code>String</code> value passed
    * in and which <b>does not</b> represent the <code>unknown value</code>
    * unless the <code>value</code> argument is <code>null</code>.
    *
    * @param    value
    *           The character value of the resulting instance.
    * @param    caseSens
    *           Specifies whether this instance should use case sensitive
    *           comparisons.
    */
   public longchar(String value, boolean caseSens)
   {
      super(value, caseSens);
   }
   
   /**
    * Constructs an instance that has a <code>char</code> value passed
    * in and which <b>does not</b> represent the <code>unknown value</code>. 
    *
    * @param    ch
    *           The character value of the resulting instance.
    */
   public longchar(char ch)
   {
      super(ch);
   }
   
   /**
    * Create a new instance, by copying the state of the passed {@link Text}.
    * 
    * @param    value
    *           The value which needs to be copied.
    */
   public longchar(Text value)
   {
      super(value, false);
   }

   /**
    * Create a new instance, by copying the state of the passed {@link Text}.
    * If the <code>output</code> parameter is set to <code>true</code>, it 
    * means that the referenced value is saved, as the passed instance will
    * be passed to a function call, and the state might need to be updated
    * on function exit. 
    * 
    * @param    value
    *           The value which needs to be copied.
    * @param    output
    *           Flag indicating if this instance is passed to as a reference
    *           for an output parameter.
    */
   public longchar(Text value, boolean output)
   {
      super(value, output);
   }

   /**
    * Returns the code page of a the specified longchar variable. If the 
    * specified LONGCHAR is empty and the code page was not fixed using the 
    * FIX-CODEPAGE statement, must return the unknown value.
    * 
    * @param    value
    *           The value for which the codepage will be retrieved.
    *
    * @return   See above
    */
   public static character getCodePage(longchar value)
   {
      // TODO: IMPLEMENT THIS
      return null;
   }
   
   /**
    * Return <code>true</code> if the codepage of the given longchar variable 
    * is fixed.
    * 
    * @param    value
    *           The value for which the codepage will be retrieved.
    *           
    * @return   See above.
    */
   public static logical isCodePageFixed(longchar value)
   {
      // TODO: IMPLEMENT THIS
      return null;
   }
   
   /**
    * Return the default display format string for this type.
    *
    * @return   The default format string.
    */
   public String defaultFormatString()   
   {
      return null;
   }
   

   /**
    * Does the same as standard <code>clone()</code> method but returns an
    * instance of <code>BaseDataType</code> and doesn't throw the
    * <code>CloneNotSupportedException</code>.
    *
    * @return   A clone of this instance.  
    */
   public BaseDataType duplicate()
   {
      return new longchar(this);
   }

   /**
    * Creates a string representation of the instance data in a form that is
    * compatible with the <code>MESSAGE</code> language statement.  If the
    * instance represents the <code>unknown value</code>, a '?' will be
    * returned.
    *
    * @return   The 'message' formatted string.
    */
   public String toStringMessage()   
   {
      // TODO: IMPLEMENT THIS
      return getValue();
   }

   /**
    * Creates a string representation of the instance data using the 'export'
    * format.  For the character data type the entire string is returned
    * enclosed in a pair of double quotes.  If the instance represents the
    * <code>unknown value</code>, a '?' will be returned.  Any instances of
    * double quotes inside the string will be doubled up on output.
    *
    * @return   The 'export' formatted string.
    */
   public String toStringExport()   
   {
      // TODO: IMPLEMENT THIS
      return getValue();
   }

   /**
    * Creates a string representation of the instance data using the user-
    * specified Progress 4GL format string.
    *
    * @param    fmt
    *           The Progress 4GL format string for a character data type.
    *
    * @return   The formatted string.
    */
  public String toString(String fmt)
   {
      // TODO: IMPLEMENT THIS
      return null;
   }
}